package eu.abra.prima.mvc01;

import java.io.IOException;
import java.io.StringReader;

import javax.ws.rs.core.MediaType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.filter.HTTPBasicAuthFilter;

@Controller
@RequestMapping(value="/backlog")
public class BacklogController {
	
	private Document parseString(String string)
	{
		// Parse XML
		DocumentBuilderFactory factory = null;
	    DocumentBuilder builder = null;
		Document doc= null;
		try {
			factory = DocumentBuilderFactory.newInstance();
			factory.setNamespaceAware(true);
			builder = factory.newDocumentBuilder();
			
			// Read string
			InputSource is = new InputSource();
	        is.setCharacterStream(new StringReader(string));
	        
			// Parse string
			doc = builder.parse(is);
			doc.getDocumentElement().normalize();
			
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}  
		return doc;
	}
	
	@RequestMapping(method=RequestMethod.GET)
	public String indexGet(Model model) {
		
		//try {
			
			//List<Feature> featuresList = new ArrayList<Feature>();
			
			Client client = Client.create();
			client.addFilter(new HTTPBasicAuthFilter("peta", "neotech")); 
			
			WebResource webResource = client.resource("https://primaerp.tpondemand.com/api/v1/Features/?include=[Id,Name]");	
			ClientResponse response = webResource.accept(MediaType.APPLICATION_XML_TYPE).get(ClientResponse.class);
			String responseString = response.getEntity(String.class);			
			model.addAttribute("featuresString", responseString);
			model.addAttribute("featuresDocument", this.parseString(responseString));
			
			webResource = client.resource("https://primaerp.tpondemand.com/api/v1/UserStories/?include=[Id,Name,Feature]&take=500");	
			response = webResource.accept(MediaType.APPLICATION_XML_TYPE).get(ClientResponse.class);
			responseString = response.getEntity(String.class);			
			model.addAttribute("storiesString", responseString);
			model.addAttribute("storiesDocument", this.parseString(responseString));
			
			
//			WebResource webResource = client.resource("https://primaerp.tpondemand.com/api/v1/Features/?include=[Id,Name]");	
//			ClientResponse response = webResource.accept(MediaType.APPLICATION_JSON_TYPE).get(ClientResponse.class);
//			
//			// Wrapper to JSON
//			String json = response.getEntity(String.class);
//			
//			model.addAttribute("featuresJsonString", json);
//			
//			ObjectMapper mapper = new ObjectMapper(); 
//            // Parse the objects into an ArrayList
//            FeaterList list = new FeaterList();
//            Feature f = new Feature();
//            f.Id = 1;
//            f.Name = "Test";
//            list.Items.add(f);
//			
//			TypeReference<FeaterList> ref = new TypeReference<FeaterList>() { };
//            try {
//				featuresList = mapper.readValue(json, ref);
//            	//mapper.writeValue(System.out, list);
//			} catch (JsonParseException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (JsonMappingException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (IOException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			
//            model.addAttribute("featuresJsonArray", featuresList);
			
			
		//}catch (Exception e) {
		//	e.printStackTrace();
		//}
		
//		try {
//			ClientConfig clientConfig = new DefaultClientConfig();
//		    clientConfig.getFeatures().put(JSONConfiguration.FEATURE_POJO_MAPPING, Boolean.TRUE);
//	
//		    Client client = Client.create(clientConfig);
//	
//			client.addFilter(new HTTPBasicAuthFilter("peta", "neotech")); 
//			
//			WebResource webResource = client.resource("https://primaerp.tpondemand.com/api/v1/Feature/?take=25&format=json");
//			
//			List<Feature> response = webResource.accept(MediaType.APPLICATION_JSON_TYPE).get(new GenericType<List<Feature>>() {});
//	
//			model.addAttribute("featuresJsonList", response);
//			
//			
//		}catch (Exception e) {
//			e.printStackTrace();
//		}
		
		
		return "backlog/index";
	}

}
