package eu.abra.prima.mvc01;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletContext;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.context.support.ServletContextResource;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

@Controller
@RequestMapping(value="/docs")
public class DocsController {
	
	private @Autowired ServletContext servletContext;
	
	@RequestMapping(method=RequestMethod.GET)
	public String indexGet(Model model) {
		
		DocumentBuilderFactory factory = null;
	    DocumentBuilder builder = null;
		Document doc= null;
		InputStream stream = null;
		
		String status = "";
		String wadlFilePath = "/resources/xml/twitter-wadl.xml";
		
		try {
			factory = DocumentBuilderFactory.newInstance();
			factory.setNamespaceAware(true);
			builder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
			status = e.toString();
		}
		
		try{	
			Resource wadlFileResource = new ServletContextResource(servletContext, wadlFilePath);
			stream = wadlFileResource.getInputStream();	
		}
		catch(Exception e)
		{
			e.printStackTrace();
			status = e.toString();
		}
		
		try {
			doc = builder.parse(stream);
			doc.getDocumentElement().normalize();
			status = "Loaded";
		} catch (SAXException e) {
			e.printStackTrace();
			status = e.toString();
		} catch (IOException e) {
			e.printStackTrace();
			status = e.toString();
		}
		
		model.addAttribute("version", "1.0");
		model.addAttribute("status", status);
		model.addAttribute("wadl", doc);
		
		return "docs/index";
	}

}
