package eu.abra.prima.mvc01;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
@RequestMapping(value="/test")
public class TestController {
	
	@RequestMapping(method=RequestMethod.GET)
	public String indexGet(Model model) {
		
		String aMessage = "Index";
		 
		model.addAttribute("message", aMessage);
		
		return "test/index";
	}
	
	@RequestMapping(method=RequestMethod.POST)
	public String indexPost(Model model) {
		
		String aMessage = "Index Posted";
		 
		model.addAttribute("message", aMessage);
		
		return "test/index";
	}
	
	@RequestMapping(value="page02", method=RequestMethod.GET)
	public String page02(@RequestParam(value="var1", required=false) String var1, Model model) {
		
		String aMessage = "Page02";
		 
		model.addAttribute("message", aMessage);
		model.addAttribute("var1", var1);
		
		return "test/page02";
	}
	
	@RequestMapping(value="page02", method=RequestMethod.POST)
	public String page02Post(@RequestParam(value="var1", required=false) String var1, Model model) {
		
		String aMessage = "Page02 Posted";
		 
		model.addAttribute("message", aMessage);
		model.addAttribute("var1", var1);
		
		return "test/page02";
	}
	
	@RequestMapping(value="page03", method=RequestMethod.GET)
	public String page03(@RequestParam(value="var1", required=false) String var1, Model model) {
		
		String aMessage = "Page03";
		 
		model.addAttribute("message", aMessage);
		model.addAttribute("var1", var1);
		
		return "test/page03";
	}
	
	@RequestMapping(value="page03", method=RequestMethod.POST)
	public String page03Post(@RequestParam(value="var1", required=false) String var1, Model model) {
		
		String aMessage = "Page03 Posted";
		 
		model.addAttribute("message", aMessage);
		model.addAttribute("var1", var1);
		
		return "test/page03";
	}

}
