<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="tiles" uri="http://tiles.apache.org/tags-tiles" %>
<!DOCTYPE html>
<!-- paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/ -->
<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="en"> <![endif]-->
<!--[if IE 7]>    <html class="no-js lt-ie9 lt-ie8" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html lang="en"> <!--<![endif]-->
<head>
	<title><tiles:getAsString name="title" /></title>
	
	<!-- Set the viewport width to device width for mobile -->
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	
	<!-- Included CSS Files -->
	<link rel="stylesheet" href="<c:url value="/resources/css/bootstrap.css" />">
	<link rel="stylesheet" href="<c:url value="/resources/css/app.css" />">

	<!-- IE Fix for HTML5 Tags -->
	<!--[if lt IE 9]>
		<script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->

</head>
<body>

	<nav class="navbar navbar-fixed-top">
		
		<tiles:insertAttribute name="navigation" />
		
	</nav>
	
	<div class="container">
		
		<header>	

				<tiles:insertAttribute name="header" />	

		</header>
		
		<nav>

				<ul class="breadcrumb">
				  <li>
				    <a href="#">Home</a> <span class="divider">/</span>
				  </li>
				  <li>
				    <a href="#">Library</a> <span class="divider">/</span>
				  </li>
				  <li class="active">Data</li>
				</ul>

		</nav>
		
		<article>	

				<tiles:insertAttribute name="body" />
		
		</article>
		
		<footer>
	
				<tiles:insertAttribute name="footer" />
	
		</footer>
		
	</div>

	<!-- Included JS Files -->
	<script src="<c:url value="/resources/js/jquery.min.js" />"></script>
	<script src="<c:url value="/resources/js/bootstrap.min.js" />"></script>
	<script src="<c:url value="/resources/js/jquery.isotope.min.js" />"></script>
	
	<script>
	$(function(){
      
		 var $container = $('#container');
		
		 $container.isotope({
		   	//itemSelector : '.element'
			animationEngine: 'best-available'
		 });
      
		// filter items when filter link is clicked
		$('#filters a').click(function(){
			var elm = $(this);
			elm.parents('ul').find('.active').removeClass('active');
			elm.parents('li').addClass('active');
			var selector = elm.attr('data-filter');
			$container.isotope({ filter: selector });
			return false;
		});
         
    });
  	</script>

</body>
</html>